--[[
--Aggro Attack by Guillotine of Draenor
--
--This add-on is made for those flimsy classes
--*cough* magespriestsdruidswarlocks
--Sorry. I have a cold
--
--Anyway, It warns your party when you are under attack
--so that they can take the aggro off of you.
--
--
--*********Changes********
--
-- 1.0b
-- - Original made
--
-----------------------------------------------
-- 1.1b
-- - Added cooldown option
-----------------------------------------------
-- 1.2b
-- - Added group check. This will only work if you are in a group.
-- - Fixed small Cooldown bug.
--]]--

AA_localInCombat = nil;
AA_playerRegenEnabled = 0;
AggroAttack_Toggled = 1;
AggroAttack_Initialized = 0;
AAis_text = "Aktiviert";
AA_CooldownTime = 15;
AA_Cooldown = true;
AA_VERSION = "1.2b";

function AggroAttack_OnLoad()
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");

   this.lastshout = 0;

   AggroAttack_Print("AggroAttack by Guillotine of Draenor v"..AA_VERSION.." loaded.",1,1,0);
   AggroAttack_Print("localization by Wolfgang Koenig, Muenich 2006",1,1,0);

	if ( AggroAttack_Initialized == 0) then
		if (not (Cosmos_RegisterConfiguration == nil)) then
			Cosmos_RegisterConfiguration(
				"COS_AA",
				"SECTION",
				AA_CONFIG_HEADER,
				AA_CONFIG_HEADER_INFO
				);
			Cosmos_RegisterConfiguration(
				"COS_AA_CHECK", --CVar
				"CHECKBOX", --CHECKBOX, SLIDER (or BOTH), BUTTON, SEPARATOR
				AA_CONFIG_TOGGLE, --Short Description String
				AA_CONFIG_TOGGLE_INFO, -- Long Description
				AggroAttack_IsItOn, --Callback
				AggroAttack_Toggled
				);
			Cosmos_RegisterConfiguration(
				"COS_AA_SLIDE",
				"SLIDER",
				AA_CONFIG_Toggle,
				AA_CONFIG_Toggle_INFO,
				AAResizeToggle,
				0,
				40,
				1,
				100,
				"Toggle Button Size",
				1,
				1,
				"",
				1
				);
			Cosmos_RegisterConfiguration(
				"COS_AA_RESET",
				"BUTTON",
				AA_CONFIG_RESET,
				AA_CONFIG_RESET_INFO,
				ResetToggleButton,
				0,
				0,
				0,
				0,
				AA_CONFIG_RESET_NAME
			);
         Cosmos_RegisterConfiguration(
            "COS_AA_COOLDOWN", 
            "SLIDER", 
            AA_COOL, 
            AA_COOL_INFO,
            AA_OnCooldownUpdate,
            1, 
            30, 
            1, 
            60, 
            AA_COOL_LIMIT, 
            1, 
            1, 
            AA_COOL_SEC,
            1	
 		);
		end
		if ( Cosmos_RegisterChatCommand ) then
			local AggroAttackMainCommands = {"/AggroAttack","/AA"};
			Cosmos_RegisterChatCommand (
				"AA_MAIN_COMMANDS", -- Some Unique Group ID
				AggroAttackMainCommands, -- The Commands
				AA_Main_ChatCommandHandler,
				AA_CHAT_COMMAND_INFO -- Description String
			);
		else
			SlashCmdList["AASLASH"] = AA_Main_ChatCommandHandler;
			SLASH_AASLASH1 = "/AggroAttack";
			SLASH_AASLASH2 = "/AA";		
		end
		AAToggleText:SetText("Toggle Button");
		AAToggleText:SetTextColor(0,1,0);
		AggroAttack_Initialized = 1;
	end
   if (AAmessage == nil) then
      AAmessage = "Ich werde angegriffen! Bitte nehmt mir die Typen ab!"
end
			AAToggleText:SetText("AggroAttack: "..AAis_text);
			AAToggleText:SetTextColor(0,1,0);
end

function AAResizeToggle(num, num2)
	if (num == 0 and num2 > 0) then
		num = num2;
	end
	if (AggroAttackFrame:IsVisible()) then
		if (num > 0 and num <= 100) then
			AAButton2:SetWidth(num);
			AAButton2:SetHeight(num);
		else
			AAButton2:SetWidth(40);
			AAButton2:SetHeight(40);
		end
	end
	if (Cosmos_RegisterConfiguration) then
		Cosmos_UpdateValue("COS_AA_SLIDE", CSM_SLIDERVALUE, num);
	end
end

function AARemoveToggle()
	if (AggroAttackFrame:IsVisible()) then
		AggroAttackFrame:Hide();
		AAButton2:Hide();
	else
		AggroAttackFrame:Show();
		AAButton2:Show();
	end
end

function ResetToggleButton()
	AggroAttackFrame:ClearAllPoints();
	AggroAttackFrame:SetPoint("TOP","UIParent","TOP", 0, -80);
end
--silly toggle.
function AggroAttack_IsItOn(x)
	AggroAttack_Toggled = x;
	if (Cosmos_RegisterConfiguration) then
		Cosmos_UpdateValue("COS_AA_CHECK", CSM_CHECKONOFF, AggroAttack_Toggled);
	end
	if (x == 0) then
	AggroAttackFrame:Hide();
	AAButton2:Hide();
	else
	AggroAttackFrame:Show();
	AAButton2:Show();
	end
end

--Sets up all the information needed and runs the meat.
function AggroAttack_OnEvent(event)
	if( event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS") then
		underattack();
		AA_localInCombat = 1;
	elseif( event == "PLAYER_LEAVE_COMBAT" ) then
		AA_localInCombat = nil;
end
end

function AggroAttack_IsPlayerInCombat() 
	if (AA_localInCombat or not AA_playerRegenEnabled) then
		return 1;
	else
		return nil;
	end
end

function AggroAttack_Toggle()
	if (AggroAttack_Toggled == 1) then
      AggroAttack_Toggled = 0;
			AAis_text = "deaktiviert";
			AggroAttack_Print("AggroAttack Meldungen sind nun ausgeschaltet",1,0,0);
         DoEmote("Toggle");
         AAToggleText:SetText("AggroAttack: "..AAis_text);
			AAToggleText:SetTextColor(1,0,0);
	else
      AggroAttack_Toggled = 1;
			AAis_text = "aktiviert";
			AggroAttack_Print("AggroAttack Meldungen sind nun eingeschaltet",0,1,0);
			AAToggleText:SetText("AggroAttack: "..AAis_text);
			AAToggleText:SetTextColor(0,1,0);

end
end

local timer = 0;
local lasttimer = 0;
local r = 1;
local b = 0;

function AggroAttack_OnUpdate(arg1)
	lasttimer = GetTime();
end

function AA_Main_ChatCommandHandler(msg)
	if ( (not msg) or (strlen(msg) <= 0) ) then
		AggroAttack_Print(AA_CHAT_COMMAND_USAGE,1,1,0);
	end
	local commandName, params = AggroAttack_Extract_NextParameter(msg);
	if ((commandName) and (strlen(commandName) > 0)) then
		commandName = string.lower(commandName);
	else
		commandName = "";
	end

	if (strfind(commandName,"check")) then
		local AAis_text = "";
		if (AggroAttack_Toggled == 1) then
			AAis_text = "Aktiviert";
		else
			AAis_text = "Deaktiviert";
		end
		AggroAttack_Print("AggroAttack is "..AAis_text);
	elseif (strfind(commandName,"toggle")) then
		AggroAttack_Toggle();
	elseif (strfind(commandName,"reset")) then
		ResetToggleButton();
	elseif (strfind(commandName,"remove")) then
		AARemoveToggle();
	elseif (strfind(commandName,"resize")) then
		if (tonumber(params)) then
			AAResizeToggle(tonumber(params));
		else
			AAResizeToggle(40);
      end
   elseif (strfind(commandName,"cooldown")) then
      if (tonumber(params)) then
         AA_OnCooldownUpdate(1,(tonumber(params)));
         AggroAttack_Print("AggroAttack Abklingzeit gesetzt auf: "..value,0,0,1);
      else
         AA_OnCooldownUpdate(1,15)
			AggroAttack_Print("AggroAttack Abklingzeit gesetzt auf: Default (15 secs)",0,0,1);
  		end
	else
		AggroAttack_Print(AA_CHAT_COMMAND_USAGE,1,1,0);
	end
end

function AggroAttack_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = "";
	end
	return command, params;
end

function AggroAttack_Print(msg,r,g,b,frame,id,unknown4th)
	if ( Print ) then
		Print(msg, r, g, b, frame, id, unknown4th);
		return;
	end
	if(unknown4th) then
		local temp = id;
		id = unknown4th;
		unknown4th = id;
	end
				
	if (not r) then r = 1.0; end
	if (not g) then g = 1.0; end
	if (not b) then b = 0.0; end
	if ( frame ) then 
		frame:AddMessage(msg,r,g,b,id,unknown4th);
	else
		if ( DEFAULT_CHAT_FRAME ) then 
			DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b,id,unknown4th);
		end
	end
end

function underattack()
 numberOfPartyMembers = GetNumPartyMembers();
   if (numberOfPartyMembers >= 1) and
   (AggroAttack_Toggled == 1) and
   (GetTime() - this.lastshout > AA_CooldownTime) then
   SendChatMessage(""..AAmessage, "PARTY");
   SendChatMessage(""..AAmessage, "SAY");
   this.lastshout = GetTime();
end
end

function AA_OnCooldownUpdate(blank,value) 
	AA_Cooldown = true; 
	AA_CooldownTime = value;
	if (Cosmos_RegisterConfiguration) then
		Cosmos_UpdateValue("COS_AA_COOLDOWN", CSM_SLIDERVALUE, AA_CooldownTime);
	end
end